const language = {
    // 中文
    cn: {
        add_btn: '添加按钮',
        add_title: '添加区域',
        del_btn: '删除按钮',
        del_title: '删除区域',
        next: '下一页',
        next_title: '下 page_size (→)',
        prev: '上一页',
        prev_title: '上 page_size (←)',
        first_title: '首页 (Shift + ←)',
        last_title: '尾页 (Shift + →)',
        get_all_btn: '获得全部 (↓)',
        get_all_alt: '(按钮)',
        close_btn: '关闭 (Tab键)',
        close_alt: '(按钮)',
        loading: '读取中...',
        loading_alt: '(读取中)',
        page_info: '第 page_num 页(共page_count页)',
        select_ng: '请注意：请从列表中选择.',
        select_ok: 'OK : 已经选择.',
        not_found: '无查询结果',
        ajax_error: '连接到服务器时发生错误！',
        clear: '清除内容',
        select_all: '选择当前页项目',
        unselect_all: '取消选择当前页项目',
        clear_all: '清除全部已选择项目',
        max_selected: '最多只能选择 max_selected_limit 个项目'
    },
    // English
    en: {
        add_btn: 'Add button',
        add_title: 'add a box',
        del_btn: 'Del button',
        del_title: 'delete a box',
        next: 'Next',
        next_title: 'Next page_size (Right key)',
        prev: 'Prev',
        prev_title: 'Prev page_size (Left key)',
        first_title: 'First (Shift + Left key)',
        last_title: 'Last (Shift + Right key)',
        get_all_btn: 'Get All (Down key)',
        get_all_alt: '(button)',
        close_btn: 'Close (Tab key)',
        close_alt: '(button)',
        loading: 'loading...',
        loading_alt: '(loading)',
        page_info: 'Page page_num of page_count',
        select_ng: 'Attention : Please choose from among the list.',
        select_ok: 'OK : Correctly selected.',
        not_found: 'not found',
        ajax_error: 'An error occurred while connecting to server.',
        clear: 'Clear content',
        select_all: 'Select current page',
        unselect_all: 'Clear current page',
        clear_all: 'Clear all selected',
        max_selected: 'You can only select up to max_selected_limit items'
    },
    // German
    de: {
        add_btn: 'Hinzufügen-Button',
        add_title: 'Box hinzufügen',
        del_btn: 'Löschen-Button',
        del_title: 'Box löschen',
        next: 'Nächsten',
        next_title: 'Nächsten page_size (Pfeil-rechts)',
        prev: 'Vorherigen',
        prev_title: 'Vorherigen page_size (Pfeil-links)',
        first_title: 'Ersten (Umschalt + Pfeil-links)',
        last_title: 'Letzten (Umschalt + Pfeil-rechts)',
        get_all_btn: 'alle (Pfeil-runter)',
        get_all_alt: '(Button)',
        close_btn: 'Schließen (Tab)',
        close_alt: '(Button)',
        loading: 'lade...',
        loading_alt: '(lade)',
        page_info: 'page_num von page_count',
        select_ng: 'Achtung: Bitte wählen Sie aus der Liste aus.',
        select_ok: 'OK : Richtig ausgewählt.',
        not_found: 'nicht gefunden',
        ajax_error: 'Bei der Verbindung zum Server ist ein Fehler aufgetreten.',
        clear: 'Löschen Sie den Inhalt',
        select_all: 'Wähle diese Seite',
        unselect_all: 'Diese Seite entfernen',
        clear_all: 'Alles löschen',
        max_selected: 'Sie können nur bis zu max_selected_limit Elemente auswählen'
    },
    // Spanish
    es: {
        add_btn: 'Agregar boton',
        add_title: 'Agregar una opcion',
        del_btn: 'Borrar boton',
        del_title: 'Borrar una opcion',
        next: 'Siguiente',
        next_title: 'Proximas page_size (tecla derecha)',
        prev: 'Anterior',
        prev_title: 'Anteriores page_size (tecla izquierda)',
        first_title: 'Primera (Shift + Left)',
        last_title: 'Ultima (Shift + Right)',
        get_all_btn: 'Ver todos (tecla abajo)',
        get_all_alt: '(boton)',
        close_btn: 'Cerrar (tecla TAB)',
        close_alt: '(boton)',
        loading: 'Cargando...',
        loading_alt: '(Cargando)',
        page_info: 'page_num de page_count',
        select_ng: 'Atencion: Elija una opcion de la lista.',
        select_ok: 'OK: Correctamente seleccionado.',
        not_found: 'no encuentre',
        ajax_error: 'Un error ocurrió mientras conectando al servidor.',
        clear: 'Borrar el contenido',
        select_all: 'Elija esta página',
        unselect_all: 'Borrar esta página',
        clear_all: 'Borrar todo marcado',
        max_selected: 'Solo puedes seleccionar hasta max_selected_limit elementos'
    },
    // Brazilian Portuguese
    'pt-br': {
        add_btn: 'Adicionar botão',
        add_title: 'Adicionar uma caixa',
        del_btn: 'Apagar botão',
        del_title: 'Apagar uma caixa',
        next: 'Próxima',
        next_title: 'Próxima page_size (tecla direita)',
        prev: 'Anterior',
        prev_title: 'Anterior page_size (tecla esquerda)',
        first_title: 'Primeira (Shift + Left)',
        last_title: 'Última (Shift + Right)',
        get_all_btn: 'Ver todos (Seta para baixo)',
        get_all_alt: '(botão)',
        close_btn: 'Fechar (tecla TAB)',
        close_alt: '(botão)',
        loading: 'Carregando...',
        loading_alt: '(Carregando)',
        page_info: 'page_num de page_count',
        select_ng: 'Atenção: Escolha uma opção da lista.',
        select_ok: 'OK: Selecionado Corretamente.',
        not_found: 'não encontrado',
        ajax_error: 'Um erro aconteceu enquanto conectando a servidor.',
        clear: 'Limpe o conteúdo',
        select_all: 'Selecione a página atual',
        unselect_all: 'Remova a página atual',
        clear_all: 'Limpar tudo',
        max_selected: 'Você só pode selecionar até max_selected_limit itens'
    },
    // Japanese
    ja: {
        add_btn: '追加ボタン',
        add_title: '入力ボックスを追加します',
        del_btn: '削除ボタン',
        del_title: '入力ボックスを削除します',
        next: '次へ',
        next_title: '次の page_size 件 (右キー)',
        prev: '前へ',
        prev_title: '前の page_size 件 (左キー)',
        first_title: '最初のページへ (Shift + 左キー)',
        last_title: '最後のページへ (Shift + 右キー)',
        get_all_btn: '全件取得 (下キー)',
        get_all_alt: '画像:ボタン',
        close_btn: '閉じる (Tabキー)',
        close_alt: '画像:ボタン',
        loading: '読み込み中...',
        loading_alt: '画像:読み込み中...',
        page_info: 'page_num 件 (全 page_count 件)',
        select_ng: '注意 : リストの中から選択してください',
        select_ok: 'OK : 正しく選択されました。',
        not_found: '(0 件)',
        ajax_error: 'サーバとの通信でエラーが発生しました。',
        clear: 'コンテンツをクリアする',
        select_all: '当ページを選びます',
        unselect_all: '移して当ページを割ります',
        clear_all: '選択した項目をクリアする',
        max_selected: '最多で max_selected_limit のプロジェクトを選ぶことしかできません'
    }
};

export default language;